-- Scorchio! 2, A multi-mob vulnerability manager
-- Copyright (C) 2008-2009  ennui@bloodhoof-eu, ennuilg@gmail.com
--
-- This program is free software; you can redistribute it and/or
-- modify it under the terms of the GNU General Public License
-- as published by the Free Software Foundation; either version 3
-- of the License, or (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program. If not, see <http://www.gnu.org/licenses/>.

-- GLOBALS: LibStub
-- GLOBALS: Scorchio2DB
-- GLOBALS: UIParent
-- GLOBALS: EnableAddOn
-- GLOBALS: LoadAddOn
-- GLOBALS: CreateFrame
-- GLOBALS: INTERFACEOPTIONS_ADDONCATEGORIES
-- GLOBALS: InterfaceOptionsFrame_OpenToCategory
-- GLOBALS: InterfaceOptions_AddCategory
local PlaySoundFile = PlaySoundFile
local UnitExists = UnitExists
local UnitGUID = UnitGUID
local UnitAura = UnitAura
local UnitDebuff = UnitDebuff
local UnitBuff = UnitBuff
local UnitName = UnitName
local UnitIsPlayer = UnitIsPlayer
local GetTime = GetTime
local IsInRaid = IsInRaid
local IsInGroup = IsInGroup
local GetNumGroupMembers = GetNumGroupMembers
local COMBATLOG_OBJECT_TYPE_PLAYER = COMBATLOG_OBJECT_TYPE_PLAYER
local COMBATLOG_OBJECT_AFFILIATION_MINE = COMBATLOG_OBJECT_AFFILIATION_MINE
local select = select
local pairs = pairs
local unpack = unpack
local tostring = tostring
local gsub = gsub
local format = format
local strfind = strfind
local bit_bor = bit.bor
local bit_band = bit.band

local mobTable
local DB
local Scorchio2
local playerGUID
local lastTargetGUID
local combatFlag

Scorchio2 = LibStub("AceAddon-3.0"):NewAddon("Scorchio2", "AceEvent-3.0", "AceConsole-3.0", "AceTimer-3.0", "LibBars-1.0", "LibSink-2.0")
_G.Scorchio2 = Scorchio2
local L = LibStub:GetLibrary("AceLocale-3.0"):GetLocale("Scorchio2")
local SM = LibStub("LibSharedMedia-3.0")
local DBVERSION = 17

-- Constants for mobTable
local MOBNAME = 1
local EXPIRATIONTIME = 2
local MAXDURATION = 3
local STACK = 4
local TIMER = 5
local BAR = 6
local TICKVALUE = 7

-- Hardcoded localizations
L["Living Bomb"] = GetSpellInfo(217694)
L["Polymorph"] = GetSpellInfo(118)
L["Slow"] = GetSpellInfo(31589)
L["Hot Streak!"] = GetSpellInfo(48108)
L["Arcane Missiles!"] = GetSpellInfo(5143)
L["Heating Up"] = GetSpellInfo(48107)
L["Brain Freeze"] = GetSpellInfo(190446)
L["Fingers of Frost"] = GetSpellInfo(44544)
L["Mirror Image"] = GetSpellInfo(55342)
L["Ignite"] = GetSpellInfo(12654)
L["Flamestrike"] = GetSpellInfo(2120)
L["Nether Tempest"] = GetSpellInfo(114923)
L["Frost Bomb"] = GetSpellInfo(112948)
L["Combustion"] = GetSpellInfo(190319)
L["Arcane Power"] = GetSpellInfo(12042)
L["Icy Veins"] = GetSpellInfo(12472)
L["Rune of Power"] = GetSpellInfo(116014)

-- Register some sounds
SM:Register("sound", "AchievementSound", [[Sound\Spells\AchievmentSound1.wav]])
SM:Register("sound", "Rubber Ducky", [[Sound\Doodad\Goblin_Lottery_Open01.wav]])
SM:Register("sound", "Cartoon FX", [[Sound\Doodad\Goblin_Lottery_Open03.wav]])
SM:Register("sound", "Explosion", [[Sound\Doodad\Hellfire_Raid_FX_Explosion05.wav]])
SM:Register("sound", "Shing!", [[Sound\Doodad\PortcullisActive_Closed.wav]])
SM:Register("sound", "Wham!", [[Sound\Doodad\PVP_Lordaeron_Door_Open.wav]])
SM:Register("sound", "Simon Chime", [[Sound\Doodad\SimonGame_LargeBlueTree.wav]])
SM:Register("sound", "War Drums", [[Sound\Event Sounds\Event_wardrum_ogre.wav]])
SM:Register("sound", "Cheer", [[Sound\Event Sounds\OgreEventCheerUnique.wav]])
SM:Register("sound", "Humm", [[Sound\Spells\SimonGame_Visual_GameStart.wav]])
SM:Register("sound", "Short Circuit", [[Sound\Spells\SimonGame_Visual_BadPress.wav]])
SM:Register("sound", "Fel Portal", [[Sound\Spells\Sunwell_Fel_PortalStand.wav]])
SM:Register("sound", "Fel Nova", [[Sound\Spells\SeepingGaseous_Fel_Nova.wav]])
SM:Register("sound", "Bats", [[Sound\Doodad\BatsFlyAway.wav]])
SM:Register("sound", "Firework", [[Sound\Doodad\G_FireworkBoomGeneral2.wav]])
SM:Register("sound", "Clockwork", [[Sound\Doodad\G_GasTrapOpen.wav]])
SM:Register("sound", "Gong", [[Sound\Doodad\G_GongTroll01.wav]])
SM:Register("sound", "Wisp", [[Sound\Event Sounds\Wisp\WispPissed1.wav]])
SM:Register("sound", "Fog Horn", [[Sound\Doodad\ZeppelinHorn.wav]])
SM:Register("sound", "Error", [[Sound\interface\Error.wav]])
SM:Register("sound", "Drop", [[Sound\interface\DropOnGround.wav]])
SM:Register("sound", "Whisper", [[Sound\interface\igTextPopupPing02.wav]])
SM:Register("sound", "Friend Login", [[Sound\interface\FriendJoin.wav]])
SM:Register("sound", "Socket Clunk", [[Sound\interface\JewelcraftingFinalize.wav]])
SM:Register("sound", "Ping", [[Sound\interface\MapPing.wav]])

-- Bar settings in the DB are referenced by these 1-letter codes.
-- a = Pyromaniac, removed
-- b = Winter's Chill, removed
local BAR_LIVING_BOMB = "c"
local BAR_POLYMORPH = "d"
local BAR_SLOW = "e"
local BAR_HOT_STREAK = "f"
local BAR_ARCANE_MISSILES = "g"
local BAR_HEATING_UP = "h"
-- i = Arcane Charge, removed
local BAR_BRAIN_FREEZE = "j"
local BAR_FINGERS_OF_FROST = "k"
-- l = Shadow Mastery, removed
-- m = Water Elemental, removed
local BAR_MIRROR_IMAGE = "n"
-- o = Torment the Weak, removed
-- p = 5% spell damage, removed
-- q = Frostfire Bolt, removed
-- r = Impact, removed
-- s = Improved Polymorph, removed
local BAR_IGNITE = "t"
-- u = Pyroblast DoT, removed
local BAR_FLAMESTRIKE = "v"
-- w = Invocation, removed
local BAR_NETHER_TEMPEST = "x"
local BAR_FROST_BOMB = "y"
local BAR_COMBUSTION = "z"
local BAR_ARCANE_POWER = "aa"
local BAR_ICY_VEINS = "bb"
local BAR_RUNE_OF_POWER = "cc"

local VULNDATA = {
	{ -- Living Bomb
		bar = BAR_LIVING_BOMB,
		spellid = 217694,
		self = false,
		durationpve = 4,
		durationpvp = 4,
		unique = false,
		valid = COMBATLOG_OBJECT_AFFILIATION_MINE,
	},
	{ -- Polymorph
		bar = BAR_POLYMORPH,
		spellid = {
			118,
			28271, -- Polymorph: Turtle
			28272, -- Polymorph: Pig
			61025, -- Polymorph: Serpent
			61305, -- Polymorph: Black Cat
			61721, -- Polymorph: Rabbit
			61780, -- Polymorph: Turkey
			126819, -- Polymorph: Porcupine
			161355, -- Polymorph: Penguin
			161353, -- Polymorph: Polar Bear Cub
			161354, -- Polymorph: Monkey
			161372, -- Polymorph: Peacock
		},
		self = false,
		durationpve = 50,
		durationpvp = 8,
		unique = true,
		valid = COMBATLOG_OBJECT_AFFILIATION_MINE,
	},
	{ -- Slow
		bar = BAR_SLOW,
		spellid = 31589,
		self = false,
		durationpve = 15,
		durationpvp = 8,
		unique = false,
		valid = COMBATLOG_OBJECT_AFFILIATION_MINE,
	},
	{ -- Hot Streak!
		bar = BAR_HOT_STREAK,
		spellid = 48108,
		self = true,
		durationpve = 15,
		durationpvp = 15,
		unique = true,
	},
	{ -- Arcane Missiles
		bar = BAR_ARCANE_MISSILES,
		spellid = 79683,
		self = true,
		durationpve = 20,
		durationpvp = 20,
		unique = true,
	},
	{ -- Heating Up
		bar = BAR_HEATING_UP,
		spellid = 48107,
		self = true,
		durationpve = 10,
		durationpvp = 10,
		unique = true,
	},
	{ -- Brain Freeze
		bar = BAR_BRAIN_FREEZE,
		spellid = 190446,
		self = true,
		durationpve = 15,
		durationpvp = 15,
		unique = true,
	},
	{ -- Fingers of Frost
		bar = BAR_FINGERS_OF_FROST,
		spellid = 44544,
		self = true,
		durationpve = 15,
		durationpvp = 15,
		unique = true,
	},
	{  -- Mirror Image
		bar = BAR_MIRROR_IMAGE,
		spellid = -55342, -- Negative for a summon bar which is handled differently
		self = true,
		durationpve = 40,
		durationpvp = 40,
		unique = true,
	},
	{ -- Ignite
		bar = BAR_IGNITE,
		spellid = 12654,
		self = false,
		durationpve = 9,
		durationpvp = 9,
		unique = false,
		valid = COMBATLOG_OBJECT_AFFILIATION_MINE,
	},
	{ -- Flamestrike
		bar = BAR_FLAMESTRIKE,
		spellid = 2120,
		self = false,
		durationpve = 8,
		durationpvp = 8,
		unique = false,
		valid = COMBATLOG_OBJECT_AFFILIATION_MINE,
	},
	{ -- Nether Tempest
		bar = BAR_NETHER_TEMPEST,
		spellid = 114923,
		self = false,
		durationpve = 12,
		durationpvp = 12,
		unique = true,
		valid = COMBATLOG_OBJECT_AFFILIATION_MINE,
	},
	{ -- Frost Bomb
		bar = BAR_FROST_BOMB,
		spellid = 112948,
		self = false,
		durationpve = 12,
		durationpvp = 12, 
		unique = true,
		valid = COMBATLOG_OBJECT_AFFILIATION_MINE,
	},
	{ -- Combustion
		bar = BAR_COMBUSTION,
		spellid = 190319,
		self = true,
		durationpve = 10,
		durationpvp = 10,
		unique = true,
		valid = COMBATLOG_OBJECT_AFFILIATION_MINE,
	},
	{ -- Arcane Power
		bar = BAR_ARCANE_POWER,
		spellid = 12042,
		self = true,
		durationpve = 10, 
		durationpvp = 10,
		unique = true,
	},
	{ -- Icy Veins
		bar = BAR_ICY_VEINS,
		spellid = 12472,
		self = true,
		durationpve = 20,
		durationpvp = 20,
		unique = true,
	},
	{ -- Rune of Power
		bar = BAR_RUNE_OF_POWER,
		spellid = -116014, -- Negative for a summon bar which is handled differently
		self = true, 
		durationpve = 10,
		durationpvp = 10,
		unique = true,
	},
}

local T = {} -- maps VULNDATA # to baroptions key. Each baroptions can have many VULNDATA referencing it.
local VULNERABILITIES = {} -- maps spellID to VULNDATA #. Each VULNDATA can have many spellids referencing it.
for i = 1,#VULNDATA do
	T[i] = VULNDATA[i].bar

	local spellid = VULNDATA[i].spellid
	if type(spellid) == "number" then
		VULNERABILITIES[spellid] = i
	elseif type(spellid) == "table" then
		for j = 1,#spellid do
			VULNERABILITIES[spellid[j]] = i
		end
	end
end

-- Utility Functions
local function Colours(pack, alpha)
	local r, g, b = unpack(pack)
	return r, g, b, alpha
end
Scorchio2.Colours = Colours

local function GetUnitIDFromGUID(GUID)
	local units = { "player", "target", "focus", "targettarget", "focustarget", "pettarget", "mouseover" }
	
	for _, unit in pairs(units) do 
		if UnitGUID(unit) == GUID then
			return unit
		end
	end
	
	if IsInRaid() then
		for i = 1, GetNumGroupMembers() do
			if UnitGUID("raid"..i.."target") == GUID then
				return "raid"..i.."target"
			end
		end
	elseif IsInGroup() then
			for i = 1, GetNumGroupMembers() do
			if UnitGUID("party"..i.."target") == GUID then
				return "party"..i.."target"
			end
		end
	end
	
	-- No need to check pet, raid/party members, or their pets, as Scorchio doesn't currently track anything that would affect friendlies other than the player.
	
	return nil
end

local function SubTokens( inputText, mobName, spellCount, tickValue)
	if mobName ~= nil then
		inputText = gsub(inputText, "$m", tostring(mobName))
	end
	if spellCount ~= nil then
		inputText = gsub(inputText, "$s", tostring(spellCount))
	end
	if tickValue ~= nil then
		inputText = gsub(inputText, "$t", tostring(tickValue))
	else
		inputText = gsub(inputText, "$t", "?")
	end
	return inputText
end
Scorchio2.SubTokens = SubTokens

-- Defaults and Options Tables
local defaults = {
	profile = {
		custom_anchors = {
		},
		anchoroptions = {
			targeted = {
				position = {
					pr = "CENTER",
					p = "CENTER",
					py = -300,
					px = 0
					},
				growth = true,
				orientation = 1,
				scale = 1.0,
				fadetime = -1,
				flash = false,
				flashtime = 6,
				iconshow = true,
				iconside = "LEFT",
				raidiconshow = false,
				raidiconpos = -10,
				texture = "Blizzard",
				width = 200,
				height = 18,
				maxbars = 0,
				font = "Arial Narrow",
				fontsize = 12
			},
			nontargeted = {
				position = {
					pr = "LEFT",
					p = "LEFT",
					py = -230,
					px = 150
					},
				growth = true,
				orientation = 1,
				scale = 1.0,
				fadetime = -1,
				flash = false,
				flashtime = 6,
				iconshow = true,
				iconside = "LEFT",
				raidiconshow = false,
				raidiconpos = -10,
				texture = "Blizzard",
				width = 200,
				height = 18,
				maxbars = 0,
				font = "Arial Narrow",
				fontsize = 12
			},
			buffs = {
				position = {
					pr = "CENTER",
					p = "CENTER",
					py = 0,
					px = 0
					},
				growth = true,
				orientation = 1,
				scale = 1.0,
				fadetime = -1,
				flash = false,
				flashtime = 6,
				iconshow = true,
				iconside = "LEFT",
				raidiconshow = false,
				raidiconpos = -10,
				texture = "Blizzard",
				width = 200,
				height = 18,
				maxbars = 0,
				font = "Arial Narrow",
				fontsize = 12
			},
		},
		baroptions = {
			a = { -- Pyromaniac, removed
			},
			b = { -- Winter's Chill, removed
			},
			c = { -- Living Bomb
				message = format(L["%s Exploded on $m"], L["Living Bomb"]),
				warning = format(L["$m Is About To Blow!"], L["Living Bomb"]),
				track = true,
				show = true,
				showproc = false,
				showwarning = false,
				showexpire = false,
				warningtime = 2,
				soundson = true,
				bar = "$m",
				warningsound = "Bell",
				expiredsound = "Info",
				fg = { 1, 0, 0 },
				bg = { 0.2, 0.2, 0.2 },
				nontargetanchor = "nontargeted",
				targetanchor = "targeted",
				nontargetalpha = 1.0,
				targetalpha = 1.0,
				clearooc = true,
				priority = 50,
				icon = "Interface\\Icons\\Ability_Mage_LivingBomb"
			},
			d = { -- Polymorph
				message = format(L["%s Broken on $m"], L["Polymorph"]),
				warning = format(L["Resheep $m!"], L["Polymorph"]),
				track = true,
				show = true,
				showproc = false,
				showwarning = true,
				showexpire = true,
				telltale = true,
				warningtime = 3,
				soundson = true,
				bar = "$m",
				warningsound = "Bell",
				expiredsound = "Info",
				fg = { 1, 0, 0.5 },
				bg = { 0.2, 0.2, 0.2 },
				nontargetanchor = "nontargeted",
				targetanchor = "targeted",
				nontargetalpha = 1.0,
				targetalpha = 1.0,
				clearooc = true,
				priority = 50,
				icon = "Interface\\Icons\\Spell_Nature_Polymorph"
			},
			e = { -- Slow
				message = format(L["%s Faded on $m"], L["Slow"]),
				warning = format(L["Recast %s on $m!"], L["Slow"]),
				track = true,
				show = true,
				showproc = false,
				showwarning = true,
				showexpire = true,
				warningtime = 3,
				soundson = true,
				bar = "$m",
				warningsound = "Bell",
				expiredsound = "Info",
				fg = { 0, 0, 0.5 },
				bg = { 0.2, 0.2, 0.2 },
				nontargetanchor = "nontargeted",
				targetanchor = "targeted",
				nontargetalpha = 1.0,
				targetalpha = 1.0,
				clearooc = true,
				priority = 50,
				icon = "Interface\\Icons\\Spell_Nature_Slow"
			},
			f = { -- Hot Streak
				apply = format(L["%s!"], L["Hot Streak!"]),
				message = format(L["%s Faded"], L["Hot Streak!"]),
				warning = format(L["Use %s Soon!"], L["Hot Streak!"]),
				track = true,
				show = true,
				showproc = true,
				showwarning = true,
				showexpire = true,
				warningtime = 2,
				soundson = true,
				bar = L["Hot Streak!"],
				procsound = "Ping",
				warningsound = "Bell",
				expiredsound = "Info",
				fg = { 1, 0.2, 0 },
				bg = { 0.2, 0.2, 0.2 },
				nontargetanchor = "buffs",
				targetanchor = "buffs",
				nontargetalpha = 1.0,
				targetalpha = 1.0,
				clearooc = false,
				priority = 50,
				icon = "Interface\\Icons\\Ability_Mage_HotStreak"
			},
			g = { -- Arcane Missiles
				apply = format(L["%s!"], L["Arcane Missiles!"]),
				message = format(L["%s Faded"], L["Arcane Missiles!"]),
				warning = format(L["Use %s Soon!"], L["Arcane Missiles!"]),
				track = true,
				show = true,
				showproc = true,
				showwarning = true,
				showexpire = true,
				warningtime = 2,
				soundson = true,
				bar = format(L["$sx %s"], L["Arcane Missiles!"]),
				procsound = "Ping",
				warningsound = "Bell",
				expiredsound = "Info",
				fg = { 0.4, 0.8, 1 },
				bg = { 0.2, 0.2, 0.2 },
				nontargetanchor = "buffs",
				targetanchor = "buffs",
				nontargetalpha = 1.0,
				targetalpha = 1.0,
				clearooc = false,
				priority = 50,
				icon = "Interface\\Icons\\Spell_Arcane_Arcane04"
			},
			h = { -- Heating Up
				apply = format(L["%s!"], L["Heating Up"]),
				message = format(L["%s Faded"], L["Heating Up"]),
				warning = format(L["Use %s Soon!"], L["Heating Up"]),
				track = true,
				show = true,
				showproc = true,
				showwarning = true,
				showexpire = true,
				warningtime = 2,
				soundson = true,
				bar = L["Heating Up"],
				procsound = "Ping",
				warningsound = "Bell",
				expiredsound = "Info",
				fg = { 0, 1, 0 },
				bg = { 0.2, 0.2, 0.2 },
				nontargetanchor = "buffs",
				targetanchor = "buffs",
				nontargetalpha = 1.0,
				targetalpha = 1.0,
				clearooc = false,
				priority = 50,
				icon = "Interface\\Icons\\Ability_Mage_HotStreak"
			},
			i = { -- Arcane Charge, removed
			},
			j = { -- Brain Freeze
				apply = format(L["%s!"], L["Brain Freeze"]),
				message = format(L["%s Faded"], L["Brain Freeze"]),
				warning = format(L["Use %s Soon!"], L["Brain Freeze"]),
				track = true,
				show = true,
				showproc = true,
				showwarning = true,
				showexpire = true,
				warningtime = 2,
				soundson = true,
				bar = format(L["$sx %s"], L["Brain Freeze"]),
				procsound = "Ping",
				warningsound = "Bell",
				expiredsound = "Info",
				fg = { 0.2, 0.4, 1 },
				bg = { 0.2, 0.2, 0.2 },
				nontargetanchor = "buffs",
				targetanchor = "buffs",
				nontargetalpha = 1.0,
				targetalpha = 1.0,
				clearooc = false,
				priority = 50,
				icon = "Interface\\Icons\\Ability_Mage_BrainFreeze"
			},
			k = { -- Fingers of Frost
				apply = format(L["%s!"], L["Fingers of Frost"]),
				message = format(L["%s Faded"], L["Fingers of Frost"]),
				warning = format(L["Use %s Soon!"], L["Fingers of Frost"]),
				track = true,
				show = true,
				showproc = true,
				showwarning = true,
				showexpire = true,
				warningtime = 2,
				soundson = true,
				bar = format("$sx %s", L["Fingers of Frost"]),
				procsound = "Ping",
				warningsound = "Bell",
				expiredsound = "Info",
				fg = { 0.2, 0.2, 1 },
				bg = { 0.2, 0.2, 0.2 },
				nontargetanchor = "buffs",
				targetanchor = "buffs",
				nontargetalpha = 1.0,
				targetalpha = 1.0,
				clearooc = false,
				priority = 50,
				icon = "Interface\\Icons\\Ability_Mage_Wintersgrasp"
			},
			l = { -- Shadow Mastery, removed
			},
			m = { -- Water Elemental, removed
			},
			n = { -- Mirror Image
				message = format(L["%s: Full Threat Restored"], L["Mirror Image"]),
				warning = format(L["%s: Threat Reduction Fading!"], L["Mirror Image"]),
				track = true,
				show = true,
				showproc = false,
				showwarning = true,
				showexpire = true,
				warningtime = 3,
				soundson = true,
				bar = L["Mirror Image"],
				warningsound = "Bell",
				expiredsound = "Info",
				fg = { 0.2, 1, 0 },
				bg = { 0.2, 0.2, 0.2 },
				nontargetanchor = "buffs",
				targetanchor = "buffs",
				nontargetalpha = 1.0,
				targetalpha = 1.0,
				clearooc = false,
				priority = 50,
				icon = "Interface\\Icons\\Spell_Magic_LesserInvisibilty"
			},
			o = { -- Torment the Weak, removed
			},
			p = { -- 5% spell damage, removed
			},
			q = { -- Frostfire Bolt, removed
			},
			r = { -- Impact, removed
			},
			s = { -- Improved Polymorph, removed
			},
			t = { -- Ignite
				message = "",
				warning = "",
				track = false,
				show = false,
				showproc = false,
				showwarning = false,
				showexpire = false,
				warningtime = 1,
				soundson = false,
				bar = "$m",
				procsound = "None",
				warningsound = "None",
				expiredsound = "None",
				fg = { 0.95, 0.95, 0.95 },
				bg = { 0.2, 0.2, 0.2 },
				nontargetanchor = "nontargeted",
				targetanchor = "targeted",
				nontargetalpha = 1.0,
				targetalpha = 1.0,
				clearooc = true,
				priority = 50,
				icon = "Interface\\Icons\\Spell_Fire_Incinerate"
			},
			u = { -- Pyroblast, removed
			},
			v = { -- Flamestrike
				message = "",
				warning = "",
				track = false,
				show = false,
				showproc = false,
				showwarning = false,
				showexpire = false,
				warningtime = 2,
				soundson = false,
				bar = "$m",
				procsound = "None",
				warningsound = "None",
				expiredsound = "None",
				fg = { 1, 0.06666666666666667, 0 },
				bg = { 0.2, 0.2, 0.2 },
				nontargetanchor = "nontargeted",
				targetanchor = "targeted",
				nontargetalpha = 1.0,
				targetalpha = 1.0,
				clearooc = true,
				priority = 50,
				icon = "Interface\\Icons\\Spell_Fire_SelfDestruct"
			},
			w = { -- Invocation, removed
			},
			x = { -- Nether Tempest
				message = format(L["%s Exploded on $m"], L["Nether Tempest"]),
				warning = format(L["$m Is About To Blow!"], L["Nether Tempest"]),
				track = true,
				show = true,
				showproc = false,
				showwarning = true,
				showexpire = true,
				warningtime = 2,
				soundson = true,
				bar = "$m",
				warningsound = "Bell",
				expiredsound = "Info",
				fg = { 1, 0, 0 },
				bg = { 0.2, 0.2, 0.2 },
				nontargetanchor = "nontargeted",
				targetanchor = "targeted",
				nontargetalpha = 1.0,
				targetalpha = 1.0,
				clearooc = true,
				priority = 50,
				icon = "Interface\\Icons\\Spell_Mage_NetherTempest"
			},
			y = { -- Frost Bomb
				message = format(L["%s Exploded on $m"], L["Frost Bomb"]),
				warning = format(L["$m Is About To Blow!"], L["Frost Bomb"]),
				track = true,
				show = true,
				showproc = false,
				showwarning = true,
				showexpire = true,
				warningtime = 2,
				soundson = true,
				bar = L["Frost Bomb"],
				warningsound = "Bell",
				expiredsound = "Info",
				fg = { 0.15, 0.75, 0.95 },
				bg = { 0.2, 0.2, 0.2 },
				nontargetanchor = "nontargeted",
				targetanchor = "targeted",
				nontargetalpha = 1.0,
				targetalpha = 1.0,
				clearooc = true,
				priority = 50,
				icon = "Interface\\Icons\\Spell_Mage_FrostBomb"
			},
			z = { -- Combustion
				message = "",
				warning = "",
				track = true,
				show = true,
				showproc = false,
				showwarning = false,
				showexpire = false,
				warningtime = 2,
				soundson = true,
				bar = L["Combustion"],
				warningsound = "None",
				expiredsound = "None",
				fg = { 0.911, 0.715, 0 },
				bg = { 0.2, 0.2, 0.2 },
				nontargetanchor = "buffs",
				targetanchor = "buffs",
				nontargetalpha = 1.0,
				targetalpha = 1.0,
				clearooc = false,
				priority = 50,
				icon = "Interface\\Icons\\Spell_Fire_SealOfFire"
			},
			aa = { -- Arcane Power
				message = "",
				warning = "",
				track = true,
				show = true,
				showproc = false,
				showwarning = false,
				showexpire = false,
				warningtime = 2,
				soundson = true,
				bar = L["Arcane Power"],
				warningsound = "None",
				expiredsound = "None",
				fg = { 0, 0, 1 },
				bg = { 0.2, 0.2, 0.2 },
				nontargetanchor = "buffs",
				targetanchor = "buffs",
				nontargetalpha = 1.0,
				targetalpha = 1.0,
				clearooc = false,
				priority = 50,
				icon = "Interface\\Icons\\Spell_Nature_Lightning"
			},
			bb = { -- Icy Veins
				message = "",
				warning = "",
				track = true,
				show = true,
				showproc = false,
				showwarning = false,
				showexpire = false,
				warningtime = 2,
				soundson = true,
				bar = L["Icy Veins"],
				warningsound = "None",
				expiredsound = "None",
				fg = { 0.125, 0.39, 0.875 },
				bg = { 0.2, 0.2, 0.2 },
				nontargetanchor = "buffs",
				targetanchor = "buffs",
				nontargetalpha = 1.0,
				targetalpha = 1.0,
				clearooc = false,
				priority = 50,
				icon = "Interface\\Icons\\Spell_Frost_Coldhearted"
			},
			cc = { -- Rune of Power
				message = "",
				warning = "",
				track = true,
				show = true,
				showproc = false,
				showwarning = false,
				showexpire = false,
				warningtime = 2,
				soundson = true,
				bar = L["Rune of Power"],
				warningsound = "None",
				expiredsound = "None",
				fg = { 0.36, 0.78, 0.92 },
				bg = { 0.2, 0.2, 0.2 },
				nontargetanchor = "buffs",
				targetanchor = "buffs",
				nontargetalpha = 1.0,
				targetalpha = 1.0,
				clearooc = false,
				priority = 50,
				icon = "Interface\\Icons\\Spell_Mage_RuneOfPower"
			},

		},
		sinkoptions = { },
		debug = {
			duplicates = false,
			sync = false,
			mob = false,
			code = false,
			timers = false,
			log = false
		},
	},
}

local IB = {} -- maps icon string to bar identifier, for sorting priority purposes.
for k,v in pairs (defaults.profile.baroptions) do
	if v.icon then
		IB[v.icon] = k
	end
end

-- Add-on Functions
function Scorchio2:OnInitialize()
	Scorchio2DB = Scorchio2DB or { dbversion = DBVERSION }
	if Scorchio2DB.dbversion ~= DBVERSION then
		-- Two things go on here. First, we have to load the Options to get the logic for upgrading databases.
		-- Second, because we loaded the options, we're responsible for calling :InitOptions.
		EnableAddOn("Scorchio2_Options")
		LoadAddOn("Scorchio2_Options")
		self:UpgradeDatabase(Scorchio2DB, DBVERSION)
		DB = LibStub("AceDB-3.0"):New("Scorchio2DB", defaults, true)
		Scorchio2:InitOptions(DB, T, VULNDATA)
	else
		DB = LibStub("AceDB-3.0"):New("Scorchio2DB", defaults, true)
	end
	Scorchio2.db = DB

	do
		local function LoadOptions()
			if Scorchio2.options_table then return end
			EnableAddOn("Scorchio2_Options")
			LoadAddOn("Scorchio2_Options")
			Scorchio2:InitOptions(DB, T, VULNDATA)
		end

		-- Command-line stubs for opening options.
		local function OpenOptions()
			LoadOptions()
			LibStub("AceConfigDialog-3.0"):Open("Scorchio2")
		end
		Scorchio2:RegisterChatCommand("scorchio", OpenOptions)
		Scorchio2:RegisterChatCommand("scorchio2", OpenOptions)

		-- UI stub for opening options, but only if we need it.
		-- Options might have already loaded for the DB upgrade.
		if not Scorchio2.options_table then
			local dummyOptionsFrame = CreateFrame("Frame")
			dummyOptionsFrame.name = "Scorchio2"
			dummyOptionsFrame:Hide()
			dummyOptionsFrame:SetScript("OnShow", function(frame)
				frame:SetScript("OnShow", nil)
				frame:Hide()
				LoadOptions()
				InterfaceOptionsFrame_OpenToCategory("Scorchio2")
			end)
			InterfaceOptions_AddCategory(dummyOptionsFrame, "Scorchio2")
		end
	end

	Scorchio2:SetSinkStorage(DB.profile.sinkoptions)

	DB.RegisterCallback(Scorchio2, "OnProfileCopied", "UpdateAnchors")
	DB.RegisterCallback(Scorchio2, "OnProfileReset", "UpdateAnchors")

	SM.RegisterCallback(Scorchio2, "LibSharedMedia_Registered", "UpdateAnchors")
	SM.RegisterCallback(Scorchio2, "LibSharedMedia_SetGlobal", "UpdateAnchors")

	Scorchio2:CreateAnchor("targeted")
	Scorchio2:CreateAnchor("nontargeted")
	Scorchio2:CreateAnchor("buffs")

	playerGUID = UnitGUID("player")
	lastTargetGUID = "0"
	mobTable = { }
	Scorchio2.mobTable = mobTable
	combatFlag = false
end

function Scorchio2:OnEnable()
	Scorchio2:RegisterEvent("PLAYER_ENTERING_WORLD")
	Scorchio2:RegisterEvent("PLAYER_REGEN_ENABLED")
	Scorchio2:RegisterEvent("PLAYER_REGEN_DISABLED")
	Scorchio2:RegisterEvent("PLAYER_TARGET_CHANGED")
	Scorchio2:RegisterEvent("PLAYER_FOCUS_CHANGED")
	Scorchio2:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
	Scorchio2:RegisterEvent("UNIT_AURA")
end

function Scorchio2:OnDisable()
	Scorchio2:UnregisterAllEvents()
end

-- Bar and Anchor Functions
function Scorchio2:CreateAnchor(anchor)
	Scorchio2[anchor] = Scorchio2:NewBarGroup(anchor, nil, DB.profile.anchoroptions[anchor].width, DB.profile.anchoroptions[anchor].height)
	Scorchio2[anchor]:ClearAllPoints()

	Scorchio2[anchor].id = anchor
	Scorchio2[anchor].RegisterCallback(Scorchio2, "AnchorClicked", "AnchorClicked")
	Scorchio2[anchor]:HideAnchor()
	Scorchio2[anchor]:SetSortFunction(Scorchio2.SortBars)
	Scorchio2:UpdateAnchor(anchor)
end

function Scorchio2:AnchorClicked(callback, group, button)
	Scorchio2:SavePosition(group.id)
	if button == "RightButton" then
		group:HideAnchor()
		group:Lock()
	end
end

function Scorchio2:ToggleAnchors(anchor)
	if Scorchio2[anchor].button:IsVisible() then
		Scorchio2[anchor]:HideAnchor()
		Scorchio2[anchor]:Lock()
	else
		Scorchio2[anchor]:ShowAnchor()
		Scorchio2[anchor]:Unlock()
	end
end

function Scorchio2:SavePosition(anchor)
	local p,_,pr,px,py = Scorchio2[anchor]:GetPoint()
	DB.profile.anchoroptions[anchor].position.p = p
	DB.profile.anchoroptions[anchor].position.pr = pr
	DB.profile.anchoroptions[anchor].position.px = px
	DB.profile.anchoroptions[anchor].position.py = py
end

function Scorchio2:UpdateAnchor(anchor)
	Scorchio2[anchor]:SetTexture(SM:Fetch("statusbar", DB.profile.anchoroptions[anchor].texture))
	Scorchio2[anchor]:SetFont(SM:Fetch("font", DB.profile.anchoroptions[anchor].font), DB.profile.anchoroptions[anchor].fontsize)
	Scorchio2[anchor]:SetWidth(DB.profile.anchoroptions[anchor].width)
	Scorchio2[anchor]:SetHeight(DB.profile.anchoroptions[anchor].height)
	Scorchio2[anchor]:SetScale(DB.profile.anchoroptions[anchor].scale)
	Scorchio2[anchor]:ReverseGrowth(DB.profile.anchoroptions[anchor].growth)
	Scorchio2[anchor]:SetOrientation(DB.profile.anchoroptions[anchor].orientation)
	if DB.profile.anchoroptions[anchor].maxbars == 0 then
		Scorchio2[anchor]:SetMaxBars(nil)
	else
		Scorchio2[anchor]:SetMaxBars(DB.profile.anchoroptions[anchor].maxbars)
	end
	Scorchio2[anchor]:SetFlashPeriod(0)

	if DB.profile.anchoroptions[anchor].flash then
		Scorchio2[anchor]:SetFlashPeriod(DB.profile.anchoroptions[anchor].flashtime)
	end

	if not DB.profile.anchoroptions[anchor].position then DB.profile.anchoroptions[anchor].position = {} end
	if DB.profile.anchoroptions[anchor].position.p
	and DB.profile.anchoroptions[anchor].position.pr
	and DB.profile.anchoroptions[anchor].position.px
	and DB.profile.anchoroptions[anchor].position.py then
		Scorchio2[anchor]:ClearAllPoints()
		Scorchio2[anchor]:SetPoint(DB.profile.anchoroptions[anchor].position.p, UIParent, DB.profile.anchoroptions[anchor].position.pr, DB.profile.anchoroptions[anchor].position.px, DB.profile.anchoroptions[anchor].position.py)
		else
			Scorchio2[anchor]:SetPoint("CENTER", UIParent, "CENTER", 0, 0)
		end
end

function Scorchio2:UpdateAnchors()
	Scorchio2:UpdateAnchor("targeted")
	Scorchio2:UpdateAnchor("nontargeted")
	Scorchio2:UpdateAnchor("buffs")
end

function Scorchio2.SortBars(a, b)
	if a.isTimer ~= b.isTimer then
		return a.isTimer
	end

	if DB.profile.baroptions[IB[a.iconTexture]].priority == DB.profile.baroptions[IB[b.iconTexture]].priority then
		if a.maxValue == b.maxValue then
			if a.value == b.value then
				return a.name > b.name
			else
				return a.value > b.value
			end
		else
			return a.maxValue > b.maxValue
		end
	else
		return DB.profile.baroptions[IB[a.iconTexture]].priority > DB.profile.baroptions[IB[b.iconTexture]].priority
	end
end

function Scorchio2:ClearBar(dstGUID, t)
	local anchorGrp = mobTable[dstGUID][t][BAR]:GetGroup()
	if anchorGrp then
		anchorGrp:RemoveBar(dstGUID.."_"..t)
		anchorGrp:SortBars()
	end
	mobTable[dstGUID][t][BAR] = nil 
end

-- Event Handling Functions
function Scorchio2:PLAYER_ENTERING_WORLD()
	playerGUID = UnitGUID("player")
end

function Scorchio2:PLAYER_REGEN_ENABLED()
	combatFlag = false
	for k, v in pairs(mobTable) do  
		for kk = 1,#T do -- Hide each bar that shouldn't be displayed in combat
			if DB.profile.baroptions[T[kk]].clearooc then
				if mobTable[k] and mobTable[k][T[kk]] and mobTable[k][T[kk]][BAR] then
					Scorchio2:ClearBar(k, T[kk])
				end
			end
		end
	end
end

function Scorchio2:PLAYER_REGEN_DISABLED()
	combatFlag = true
	for k, v in pairs(mobTable) do
		for kk = 1,#T do -- Redraw each bar that should be displayed in combat
			if DB.profile.baroptions[T[kk]].clearooc then
				if mobTable[k] and mobTable[k][T[kk]] then
					Scorchio2:UpdateTable(k, kk)
				end
			end
		end
	end
end

function Scorchio2:PLAYER_TARGET_CHANGED()
	if mobTable[lastTargetGUID] then
		for k = 1,#T do
			if mobTable[lastTargetGUID][T[k]] then
				if mobTable[lastTargetGUID][T[k]][BAR] then
					Scorchio2:ClearBar(lastTargetGUID, T[k])
					Scorchio2:UpdateTable(lastTargetGUID, k)
				end
			end
		end
	end
	if UnitExists("target") then
		lastTargetGUID = UnitGUID("target")
		for k = 1,#T do
			if mobTable[lastTargetGUID] then
				if mobTable[lastTargetGUID][T[k]] then
					if mobTable[lastTargetGUID][T[k]][BAR] then
						Scorchio2:ClearBar(lastTargetGUID, T[k])
						Scorchio2:UpdateTable(lastTargetGUID, k)
					end
				end
			end
		end
		Scorchio2:ScanAuras("target") -- Make sure we have complete & accurate info on our new target
	else
		lastTargetGUID = "0"
	end
end

function Scorchio2:PLAYER_FOCUS_CHANGED()
	if UnitExists("focus") then -- Make sure we have complete & accurate info on our new focus
		Scorchio2:ScanAuras("focus")
	end
end

-- This is required to detect buff refreshes/duration changes on the player himself.  
-- For example, Overpowered/Thermal Void talents' duration adjustments.
function Scorchio2:UNIT_AURA(event, unitID)
	if unitID == "player" then
		Scorchio2:ScanAuras("player")
	end
end

function Scorchio2:COMBAT_LOG_EVENT_UNFILTERED(_, _, event, hideCaster, srcGUID, srcName, srcFlags, srcRaidFlags, dstGUID, dstName, dstFlags, dstRaidFlags, ...)
	local timeStamp = GetTime()
	local _, _, prefix, suffix = strfind(event, "(.-)_(.+)")

	if (prefix == "SPELL") then
		local spellID, spellName, spellSchool = ...
		
		local isPlayer = false
		if bit_band(dstFlags, COMBATLOG_OBJECT_TYPE_PLAYER) == COMBATLOG_OBJECT_TYPE_PLAYER then
			isPlayer = true
		end
		
		local k = VULNERABILITIES[spellID]
		local valid = false
		if k then 
			if VULNDATA[k].self == true then
				if dstGUID == playerGUID then
					valid = true
				end
			else
				if (VULNDATA[k].valid == nil) or (bit_band(srcFlags, VULNDATA[k].valid) ~= 0) then
					valid = true
				end
			end
		end

		if (suffix == "SUMMON") then 
			if spellID == 58833 and bit_band(srcFlags, COMBATLOG_OBJECT_AFFILIATION_MINE) ~= 0 and DB.profile.baroptions.n.track then -- Mirror Image
				Scorchio2:UpdateTable(srcGUID, VULNERABILITIES[-55342], srcName, timeStamp, timeStamp + VULNDATA[VULNERABILITIES[-55342]].durationpve, 1, true, nil, VULNDATA[VULNERABILITIES[-55342]].durationpve)
			end
			if spellID == 116011 and bit_band(srcFlags, COMBATLOG_OBJECT_AFFILIATION_MINE) ~= 0 and DB.profile.baroptions.cc.track then -- Rune of Power
				Scorchio2:UpdateTable(srcGUID, VULNERABILITIES[-116014], srcName, timeStamp, timeStamp + VULNDATA[VULNERABILITIES[-116014]].durationpve, 1, true, nil, VULNDATA[VULNERABILITIES[-116014]].durationpve)
			end
		elseif (suffix == "AURA_BROKEN_SPELL") then
			if valid then
				local extraSpellID, extraSpellName, extraSchool, auraType = select(4, ...)
				Scorchio2:AuraBroken(dstGUID, srcName, extraSpellName)
			end
		elseif (suffix == "AURA_BROKEN") then
			if valid then
				local auraType = select(4, ...)
				Scorchio2:AuraBroken(dstGUID, srcName, L["Hitting It!"])
			end
		elseif (suffix == "AURA_APPLIED") then
			if valid then
				local spellAuraType, spellCount = select(4, ...)
				Scorchio2:ApplyVuln(spellID, spellName, spellCount, timeStamp, dstGUID, dstName, isPlayer, srcFlags, dstFlags, srcGUID)
			end
		elseif (suffix == "AURA_APPLIED_DOSE") then
			if valid then
				local spellAuraType, spellCount = select(4, ...)
				Scorchio2:ApplyVuln(spellID, spellName, spellCount, timeStamp, dstGUID, dstName, isPlayer, srcFlags, dstFlags, srcGUID)
			end
		elseif (suffix == "AURA_REFRESH") then
			if valid then
				local spellAuraType, spellCount = select(4, ...)
				Scorchio2:ApplyVuln(spellID, spellName, spellCount, timeStamp, dstGUID, dstName, isPlayer, srcFlags, dstFlags, srcGUID)
			end
		elseif (suffix == "AURA_REMOVED") then
			if valid then
				local spellAuraType, spellCount = select(4, ...)
				Scorchio2:LostVuln(spellID, timeStamp, dstGUID)
			end
		elseif (suffix == "AURA_REMOVED_DOSE") then
			if valid then
				local spellAuraType, spellCount = select(4, ...)
				Scorchio2:LostVuln(spellID, timeStamp, dstGUID)
			end
		end
	elseif (prefix == "UNIT") then -- must be UNIT_DIED or UNIT_DESTROYED
		if dstName ~= nil and mobTable[dstGUID] ~= nil then
			Scorchio2:MobDies(dstGUID, dstName)
		end
	end
end

function Scorchio2:ApplyVuln(spellID, spellName, spellCount, timeStamp, dstGUID, dstName, isPlayer, srcFlags, dstFlags, srcGUID)
	local k = VULNERABILITIES[spellID]
	if k and DB.profile.baroptions[T[k]].track then
		local tickValue = nil
		local expiration = nil
		local maxDuration = nil

		local u = GetUnitIDFromGUID(dstGUID)
		if u and UnitExists(u) then
			local auraFilter
			if VULNDATA[k].self then 
				auraFilter = "HELPFUL|HARMFUL"
			else
				auraFilter = "HARMFUL|PLAYER" 
			end
			local name, rank, icon, count, bType, duration, expire, caster, isStealable, _, sid, apply, isBossDebuff, _, _, _, v1, v2, v3 = UnitAura(u, spellName, nil, auraFilter)
			if name and (spellID == sid) then
				expiration = expire
				spellCount = count
				tickValue = v1
				maxDuration = duration
			end
		end
		
		if spellCount == nil then -- We'll guess, shouldn't matter because the only auras with stacks that Scorchio cares about are on the player himself, who is always going to be able to be live scanned above
			spellCount = 1
		end
		
		if VULNDATA[k].self then
			if dstGUID == playerGUID then
				if maxDuration == nil then -- Couldn't access the unit for a live scan, fall back to the default durations.
					maxDuration = VULNDATA[k].durationpvp
				end
		
				if expiration == nil then -- Couldn't access the unit for a live scan, fall back to the default durations.
					expiration = timeStamp + maxDuration
				end
		
				Scorchio2:UpdateTable(dstGUID, k, dstName, timeStamp, expiration, spellCount, isPlayer, nil, maxDuration)
			end
		else
			if maxDuration == nil then -- Couldn't access the unit for a live scan, fall back to the default durations.
				if isPlayer then
					maxDuration = VULNDATA[k].durationpvp
				else
					maxDuration = VULNDATA[k].durationpve
				end
			end
	
			if expiration == nil then -- Couldn't access the unit for a live scan, fall back to the default durations.
				expiration = timeStamp + maxDuration
			end
			
			Scorchio2:UpdateTable(dstGUID, k, dstName, timeStamp, expiration, spellCount, isPlayer, nil, maxDuration, tickValue)
		end
	end
end

function Scorchio2:LostVuln(spellID, timeStamp, dstGUID)
	local k = VULNERABILITIES[spellID]
	if k and mobTable[dstGUID] and mobTable[dstGUID][T[k]] then
		if mobTable[dstGUID][T[k]][BAR] then
			Scorchio2:ClearBar(dstGUID, T[k])
		end
		if mobTable[dstGUID][T[k]][TIMER] then
			Scorchio2:CancelTimer(mobTable[dstGUID][T[k]][TIMER], true)
			mobTable[dstGUID][T[k]][TIMER] = nil
		end
	
		if combatFlag or not DB.profile.baroptions[T[k]].clearooc then
			if mobTable[dstGUID][T[k]][EXPIRATIONTIME] - 0.25 <= timeStamp then -- Only natural expirations, not expirations due to death/dispel/etc.
				if DB.profile.baroptions[T[k]].soundson then
					PlaySoundFile(SM:Fetch("sound", DB.profile.baroptions[T[k]].expiredsound), "Master")
				end
				if DB.profile.baroptions[T[k]].showexpire then
					Scorchio2:Pour(SubTokens(DB.profile.baroptions[T[k]].message, mobTable[dstGUID][T[k]][MOBNAME]), 1, 0, 0)
				end
			end
		end
	
		mobTable[dstGUID][T[k]] = nil
	end
end

function Scorchio2:ScanAuras(unitID)
	local dstGUID = UnitGUID(unitID)
	local dstName = UnitName(unitID)
	local isPlayer = UnitIsPlayer(unitID)
	
	if (unitID == "player") then -- Scan buffs only
		local i = 1
		local buffsPresent = {}
		while true do
			local _, _, icon, spellCount, _, duration, expirationTime, unitCaster, _, _, spellID, apply, isBossDebuff, _, _, _, v1, v2, v3 = UnitBuff(unitID, i)
			local now = GetTime()
			if icon == nil then break end
			buffsPresent[spellID] = true
			local k = VULNERABILITIES[spellID]
			if k and DB.profile.baroptions[T[k]].track then
				if (VULNDATA[k].self) then
					if duration == nil then
						duration = VULNDATA[k].durationpvp
					end
					Scorchio2:UpdateTable(dstGUID, k, dstName, now, expirationTime, spellCount, isPlayer, nil, duration, v1)
				end
			end
			i = i + 1
		end
		for v = 1,#VULNDATA do
			if VULNDATA[v].self == true then
				local spellid = VULNDATA[v].spellid
				if type(spellid) == "number" then
					if spellid > 0 and buffsPresent[spellid] == nil and mobTable[dstGUID] and 
						mobTable[dstGUID][T[VULNERABILITIES[spellid]]] and
						mobTable[dstGUID][T[VULNERABILITIES[spellid]]][BAR] then
						Scorchio2:LostVuln(spellid, GetTime(), dstGUID)
					end
				elseif type(spellid) == "table" then
					local foundOne = false
					for j = 1,#spellid do
						if spellid[j] < 0 or buffsPresent[spellid[j]] ~= nil then
							foundOne = true
						end
					end
					if foundOne == false and mobTable[dstGUID] and 
					   mobTable[dstGUID][T[VULNERABILITIES[spellid[1]]]] and
					   mobTable[dstGUID][T[VULNERABILITIES[spellid[1]]]][BAR] then
						Scorchio2:LostVuln(spellid[1], GetTime(), dstGUID)
					end
				end
			end
		end
	else -- Scan debuffs only
		local i = 1
		local debuffsPresent = {}
		while true do
			local _, _, icon, spellCount, _, duration, expirationTime, unitCaster, _, _, spellID, apply, isBossDebuff, _, _, _, v1, v2, v3 = UnitDebuff(unitID, i)
			local now = GetTime()
			if icon == nil then break end
			debuffsPresent[spellID] = true
			local k = VULNERABILITIES[spellID]
			if k and DB.profile.baroptions[T[k]].track then
				if (VULNDATA[k].valid == COMBATLOG_OBJECT_AFFILIATION_MINE and unitCaster == "player") or (VULNDATA[k].valid ~= COMBATLOG_OBJECT_AFFILIATION_MINE) then
					if duration == nil then
						if isPlayer then
							duration = VULNDATA[k].durationpvp
						else
							duration = VULNDATA[k].durationpve
						end
					end
					Scorchio2:UpdateTable(dstGUID, k, dstName, now, expirationTime, spellCount, isPlayer, nil, duration, v1)
				end
			end
			i = i + 1
		end
		for v = 1,#VULNDATA do
			if VULNDATA[v].self == false then
				local spellid = VULNDATA[v].spellid
				if type(spellid) == "number" then
					if spellid > 0 and debuffsPresent[spellid] == nil and mobTable[dstGUID] and 
						mobTable[dstGUID][T[VULNERABILITIES[spellid]]] and
						mobTable[dstGUID][T[VULNERABILITIES[spellid]]][BAR] then
						Scorchio2:LostVuln(spellid, GetTime(), dstGUID)
					end
				elseif type(spellid) == "table" then
					local foundOne = false
					for j = 1,#spellid do
						if spellid[j] < 0 or debuffsPresent[spellid[j]] ~= nil then
							foundOne = true
						end
					end
					if foundOne == false and mobTable[dstGUID] and 
					   mobTable[dstGUID][T[VULNERABILITIES[spellid[1]]]] and
					   mobTable[dstGUID][T[VULNERABILITIES[spellid[1]]]][BAR] then
						Scorchio2:LostVuln(spellid[1], GetTime(), dstGUID)
					end
				end
			end
		end
	end

end

function Scorchio2:UpdateTable(dstGUID, vulnKey, dstName, timeStamp, expiration, spellCount, isPlayer, testMode, maxDuration, tickValue)
	if mobTable[dstGUID] == nil then
		mobTable[dstGUID] = { }
	end
	if mobTable[dstGUID][T[vulnKey]] == nil then
		mobTable[dstGUID][T[vulnKey]] = { }
		mobTable[dstGUID][T[vulnKey]][MOBNAME] = dstName
		
		if DB.profile.baroptions[T[vulnKey]].soundson then
			PlaySoundFile(SM:Fetch("sound", DB.profile.baroptions[T[vulnKey]].procsound), "Master")
		end
		if DB.profile.baroptions[T[vulnKey]].showproc then
			Scorchio2:Pour(DB.profile.baroptions[T[vulnKey]].apply, 1, 0, 0)
		end
	else
		dstName = mobTable[dstGUID][T[vulnKey]][MOBNAME]
	end

	local anchor, alpha
	if testMode ~= nil then
		anchor = testMode
		alpha = 1.0
	else
		if dstGUID == UnitGUID("target") then
			anchor = DB.profile.baroptions[T[vulnKey]].targetanchor
			alpha = DB.profile.baroptions[T[vulnKey]].targetalpha
		else
			anchor = DB.profile.baroptions[T[vulnKey]].nontargetanchor
			alpha = DB.profile.baroptions[T[vulnKey]].nontargetalpha
		end
	end

	if maxDuration ~= nil then
		mobTable[dstGUID][T[vulnKey]][MAXDURATION] = maxDuration
	else
		maxDuration = mobTable[dstGUID][T[vulnKey]][MAXDURATION]
	end

	if expiration ~= nil then
		mobTable[dstGUID][T[vulnKey]][EXPIRATIONTIME] = expiration
	else
		expiration = mobTable[dstGUID][T[vulnKey]][EXPIRATIONTIME]
	end
	
	if expiration <= GetTime() then
		mobTable[dstGUID][T[vulnKey]] = nil
		return
	end

	if spellCount ~= nil then
		mobTable[dstGUID][T[vulnKey]][STACK] = spellCount
	else
		spellCount = mobTable[dstGUID][T[vulnKey]][STACK]
	end

	if VULNDATA[vulnKey].storeticks then
		if tickValue ~= nil then
			mobTable[dstGUID][T[vulnKey]][TICKVALUE] = tickValue
		else
			tickValue = mobTable[dstGUID][T[vulnKey]][TICKVALUE]
		end
	end
	
	if testMode or (DB.profile.baroptions[T[vulnKey]].show and anchor ~= "none" and (combatFlag or not DB.profile.baroptions[T[vulnKey]].clearooc)) then
		if VULNDATA[vulnKey].unique then -- If spell is flagged as unique, immediately remove any one that was up on a different mob
			for k, v in pairs(mobTable) do
				if mobTable[k][T[vulnKey]] then
					if mobTable[k][T[vulnKey]][BAR] then
						Scorchio2:ClearBar(k, T[vulnKey])
					end
					if mobTable[k][T[vulnKey]][TIMER] then
						Scorchio2:CancelTimer(mobTable[k][T[vulnKey]][TIMER], true)
						mobTable[k][T[vulnKey]][TIMER] = nil
					end
				end
			end
		end
	
		local icon = DB.profile.baroptions[T[vulnKey]].icon
		local barText = SubTokens(DB.profile.baroptions[T[vulnKey]].bar, dstName, spellCount, tickValue)
		if mobTable[dstGUID][T[vulnKey]][BAR] then
			Scorchio2:ClearBar(dstGUID, T[vulnKey])
		end
		local newBar = Scorchio2[anchor]:NewTimerBar(tostring(dstGUID .. "_" .. T[vulnKey]), barText, expiration - GetTime(), maxDuration, icon, 0)
		newBar.texture:SetVertexColor(Colours(DB.profile.baroptions[T[vulnKey]].fg, alpha))
		newBar.bgtexture:SetVertexColor(Colours(DB.profile.baroptions[T[vulnKey]].bg, alpha))
		newBar.label:SetWordWrap(false)
		mobTable[dstGUID][T[vulnKey]][BAR] = newBar
	end

	local warningTime = DB.profile.baroptions[T[vulnKey]].warningtime
	if warningTime > 0 and DB.profile.baroptions[T[vulnKey]].showwarning then
		if mobTable[dstGUID][T[vulnKey]][TIMER] ~= nil then
			Scorchio2:CancelTimer(mobTable[dstGUID][T[vulnKey]][TIMER], true)
		end
		mobTable[dstGUID][T[vulnKey]][TIMER] = Scorchio2:ScheduleTimer("TimerComplete", expiration - GetTime() - warningTime, { dstGUID , vulnKey })
	end
end

function Scorchio2:MobDies(dstGUID, dstName)
	for k = 1,#T do
		if mobTable[dstGUID][T[k]] then
			if mobTable[dstGUID][T[k]][BAR] then
				Scorchio2:ClearBar(dstGUID, T[k])
			end
			if mobTable[dstGUID][T[k]][TIMER] then
				Scorchio2:CancelTimer(mobTable[dstGUID][T[k]][TIMER], true)
				mobTable[dstGUID][T[k]][TIMER] = nil
			end
		end
	end
	mobTable[dstGUID] = nil
end

function Scorchio2:AuraBroken(dstGUID, srcName, cause)
	if dstGUID and mobTable[dstGUID] then
		if mobTable[dstGUID][T[VULNERABILITIES[118]]] and DB.profile.baroptions.d.telltale then
			local telltale = format(L["%s Broken on $m by $n"], L["Polymorph"])
			telltale = telltale:gsub("$m", tostring(mobTable[dstGUID][T[VULNERABILITIES[118]]][MOBNAME]))
			telltale = telltale:gsub("$n", srcName)
			telltale = telltale .. " (" .. tostring(cause) .. ")"
			Scorchio2:Pour(telltale, 1, 1, 1)
			Scorchio2:Print(telltale)
		end
	end
end

function Scorchio2:TimerComplete(info)
	local dstGUID, vulnKey = info[1], info[2]
	if mobTable[dstGUID][T[vulnKey]] then
		if combatFlag or not DB.profile.baroptions[T[vulnKey]].clearooc then
			if DB.profile.baroptions[T[vulnKey]].soundson then
				PlaySoundFile(SM:Fetch("sound", DB.profile.baroptions[T[vulnKey]].warningsound), "Master")
			end
			Scorchio2:Pour(SubTokens(DB.profile.baroptions[T[vulnKey]].warning, mobTable[dstGUID][T[vulnKey]][MOBNAME]), 1, 0.647, 0)
		end
	end
end

function Scorchio2:RunTest(anchor)
	local now = GetTime()
	if anchor == "buffs" then
		Scorchio2:UpdateTable("Test1-"..anchor, VULNERABILITIES[48108], "Hot Streak!", now, now + VULNDATA[VULNERABILITIES[48108]].durationpvp, 1, true, anchor) -- Hot Streak!
		Scorchio2:UpdateTable("Test2-"..anchor, VULNERABILITIES[79683], "Arcane Missiles!", now, now + VULNDATA[VULNERABILITIES[79683]].durationpvp, 1, true, anchor) -- Arcane Missiles!
	else
		Scorchio2:UpdateTable("Test1-"..anchor, VULNERABILITIES[217694], "Test Mob 1", now, now + VULNDATA[VULNERABILITIES[217694]].durationpve, 1, false, anchor) -- Living Bomb
		Scorchio2:UpdateTable("Test2-"..anchor, VULNERABILITIES[2120], "Test Mob 2", now, now + VULNDATA[VULNERABILITIES[2120]].durationpve, 1, false, anchor) -- Flamestrike
		Scorchio2:UpdateTable("Test3-"..anchor, VULNERABILITIES[118], "Test Mob 3", now, now + VULNDATA[VULNERABILITIES[118]].durationpve, 1, false, anchor) -- Polymorph
		Scorchio2:UpdateTable("Test4-"..anchor, VULNERABILITIES[31589], "Test Mob 4", now, now + VULNDATA[VULNERABILITIES[31589]].durationpve, 1, false, anchor) -- Slow
	end
end
